<template>
  <div>
    <div style="margin: 3rem">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <!-- buscador -->
        <el-col :span="5" :offset="12">
          <app-search-filter v-model="textSearch" style="margin:1rem 0 1rem 96%"></app-search-filter>
        </el-col>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray text-white" style="padding:10px 20px">
          <span class="text-bold" style="font-size:20px">RECEPCIÓN:</span> <span class="text-white" style="font-size:20px"> {{titleContract}}</span>
        </el-col>
      </el-header>
      <el-col style="margin:2rem 0; padding:0 10rem">
        <p class="text-bold">Total de Materiales: <span>{{totalMaterial}}</span></p>
        <p class="text-orange text-bold" style="margin:7px 0">Materiales Recibidos: <span>{{receivedMaterials}}</span></p>
      </el-col>
      <!-- <el-col style="margin:1rem 0; padding:0 10rem">
        <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="CheckAllMat">Marcar todos</el-checkbox>
      </el-col> -->
      <el-main style="margin-top:10rem; margin-left:10%; width:80%">
        <el-col v-for="(mat, index) in searching" :key="index">
          <el-card :body-style="{ padding: '0px'}" style="margin-bottom:3rem">
            <div :class="[ mat.hideForm?'bg-gray':'bg-white' ]" style="height:100%; min-height:7rem">
              <el-row style="margin:0rem; padding:1rem 2rem">
                <el-col :span="1"><i class="el-icon-caret-right" :class="[ mat.hideForm?'text-orange':'arrow-gray']" style="font-size:35px"  @click="showFormCard(index)"></i></el-col>
                <el-col :span="21" style="padding:7px 21px 0">
                  <!-- <span class="text-bold" style="font-size:20px">{{mat.listTitle}}</span> -->
                  <span class="text-bold" style="font-size:20px">{{mat.originalTitle}}</span>
                  <!-- <span class="text-dark-gray-1" style="font-size:16px;  margin-left:1rem">{{textCounterAboutTypeOfContent(mat)}} </span> -->
                  <span class="text-dark-gray-1" style="font-size:16px;  margin-left:1rem">N° en el Contrato: ({{mat.contractPosition}})</span>
                  <span class="text-bold text-red" style="font-size:16px; margin-left:2rem">{{mat.showreplace}}</span>
                </el-col>
                <el-col :span="2"><img src="@/assets/images/borrador-rojo.svg" alt="borrador" @click="btnClean(index, searching, 'materialall')"></el-col>
                <el-col :span="24" style="padding:20px 58px 0">
                  <el-radio-group v-model="mat.statusMaterial" v-if="mat.numChapters.length > 0">
                    <el-radio :label="1">Pendiente</el-radio>
                    <el-radio :label="2">Incompleto</el-radio>
                    <el-radio :label="3">Completo</el-radio>
                  </el-radio-group>
                  <el-radio-group v-model="mat.statusMaterial" v-else @change="changeStatusMaterial(mat.statusMaterial, index)">
                    <el-radio :label="1">Pendiente</el-radio>
                    <el-radio :label="3">Recibido</el-radio>
                  </el-radio-group>
                </el-col>
              </el-row>
              <hr class="bg-gray" v-if="mat.hideForm">
              <!-- si tiene temporadas y capítulos-->
              <!-- cambios porque ahora se jala de  contratos -->
              <!-- <el-row class="bg-white" style="padding:2rem 5.7rem" v-show="mat.hideForm" v-if="mat.numChapters"> -->
                 <el-row class="bg-white" style="padding:2rem 5.7rem" v-show="mat.hideForm" v-if="mat.numChapters.length !== 0">
                <el-col :span="24" :offset="18">
                  <el-select v-model="mat.selectSeason" placeholder="Temporada" size="small" clearable>
                    <el-option
                      v-for="aSeason in mat.allSeason"
                      :key="aSeason.value"
                      :label="aSeason.label"
                      :value="aSeason.value">
                    </el-option>
                  </el-select>
                </el-col>
                <el-col v-for="(seas, ind) in mat.numChapters" :key="ind">
                  <!--  v-if="seas.season === mat.selectSeason" -->
                  <el-col :span="24" style="margin:0.7rem 0">
                    <p class="text-bold" style="margin:0.5rem 0 2rem; font-size:17px">Temporada {{seas.season}}</p>
                    <p class="margin-between">Total de Capítulos: {{seas.chapters}}</p>
                    <p class="text-orange margin-between">Capítulos Recibidos: {{receivedChapter(seas)}}</p>
                    <hr style="margin:1.5rem 0">
                    <el-col v-for="(cap, j) in seas.infoByChapter" :key="j" style="margin:1rem 0">
                      <el-row class="bg-gray" type="flex" align="middle">
                        <el-col :span="1"><i class="el-icon-caret-right" style="font-size:25px; color:#828282" @click="showCap(index, ind, j)"></i></el-col>
                        <el-col :span="6">Capítulo {{cap.chapter}}</el-col>
                        <el-col :span="10">
                          <el-radio-group v-model="cap.statusChapter" v-if="mat.numChapters" @change="changeStatusMaterial(cap.statusChapter, index, ind, j)">
                            <el-radio :label="1">Pendiente</el-radio>
                            <el-radio :label="2">Recibido</el-radio>
                          </el-radio-group>
                        </el-col>
                        <el-col :span="5">
                          <span class="text-bold text-red" style="font-size:14px; margin-left:2rem">{{cap.showreplace}}</span>
                        </el-col>
                        <el-col :span="2">
                          <img src="@/assets/images/borrador-rojo.svg" alt="borrador" style="width:32px" @click="btnClean(j, seas.infoByChapter, 'chapter')">
                        </el-col>
                      </el-row>
                      <el-row style="margin-top:1rem" v-show="cap.hideChap">
                        <el-card :body-style="{ padding: '2rem 3rem'}" >
                          <el-col :span="24" style="margin:0.7rem 0">
                            <el-col :span="5" style="margin-top:0.5rem"><span>Fecha de llegada:</span></el-col>
                            <el-col :span="4">
                              <el-date-picker
                                v-model="cap.arrivalDate" type="date" size="small"
                                placeholder="Seleccionar" format="dd/MM/yyyy" value-format="timestamp" class="vigencia-size">
                              </el-date-picker>
                            </el-col>            
                          </el-col>
                          <el-col :span="24" style="margin:0.7rem 0">
                            <el-col :span="5" style="margin-top:0.5rem"><span>Soporte de llegada:</span></el-col>
                            <el-col :span="6">
                              <app-select v-model="cap.arrivalSupport" :filterArray="allFilters" size="small"></app-select>
                            </el-col>            
                          </el-col>
                          <el-col :span="24" style="margin:0.7rem 0">
                            <el-col :span="5" style="margin-top:0.5rem"><span>Modo de Envío:</span></el-col>
                            <el-col :span="6">
                              <app-select v-model="cap.shippingMode" :filterArray="allShipping" size="small"></app-select>
                            </el-col>            
                          </el-col>
                          <el-col :span="24" style="margin:0.7rem 0 3rem">
                            <el-col :span="5" style="margin-top:0.5rem"><span>Número de Guía:</span></el-col>
                            <el-col :span="6">
                              <el-input v-model="cap.guideNumber" size="small" :disabled="chooseGuideNumber(cap.arrivalDate, cap.arrivalSupport, cap.shippingMode)"></el-input>
                            </el-col>            
                          </el-col>
                          <el-col :offset="21">
                            <el-button @click="btnCopy(cap, j, seas.infoByChapter, 'chap')" size="small" type="primary" style="margin-bottom:2rem"> COPIAR</el-button>                           
                          </el-col>
                        </el-card>
                      </el-row>
                    </el-col>
                  </el-col>
                </el-col>
              </el-row>
              <el-row class="bg-white" style="padding:2rem 5.7rem" v-show="mat.hideForm" v-else>
                <el-col :span="24" style="margin:0.7rem 0">
                  <el-col :span="5" style="margin-top:0.5rem"><span>Fecha de llegada:</span></el-col>
                  <el-col :span="4">
                    <el-date-picker
                      v-model="mat.arrivalDate" type="date" size="small"
                      placeholder="Seleccionar" format="dd/MM/yyyy" value-format="timestamp" class="size-arrival">
                    </el-date-picker>
                  </el-col>            
                </el-col>
                <el-col :span="24" style="margin:0.7rem 0">
                  <el-col :span="5" style="margin-top:0.5rem"><span>Soporte de llegada:</span></el-col>
                  <el-col :span="6">
                    <app-select v-model="mat.arrivalSupport" :filterArray="allFilters" size="small"></app-select>
                  </el-col>            
                </el-col>
                <el-col :span="24" style="margin:0.7rem 0">
                  <el-col :span="5" style="margin-top:0.5rem"><span>Modo de Envío:</span></el-col>
                  <el-col :span="6">
                    <app-select v-model="mat.shippingMode" :filterArray="allShipping" size="small"></app-select>
                  </el-col>            
                </el-col>
                <el-col :span="24" style="margin:0.7rem 0 3rem">
                  <el-col :span="5" style="margin-top:0.5rem"><span>Número de Guía:</span></el-col>
                  <el-col :span="6">
                    <el-input v-model="mat.guideNumber" size="small" :disabled="chooseGuideNumber(mat.arrivalDate, mat.arrivalSupport, mat.shippingMode)"></el-input>
                  </el-col>            
                </el-col>
                <el-col :offset="22">
                  <el-button @click="btnCopy(mat, index, searching, 'nochap')" size="small" style="margin-right:2.5rem" type="primary"> COPIAR</el-button>
                </el-col>
              </el-row>
              <!-- Modal botón copiar -->
              <AppModal :show-dialog.sync="modalCopy" v-if="modalCopy" nameClass="dialog-orange"  :rutImg="require(`@/assets/images/suspicious.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
                :parrafo="paragraph"
                classBtn1="border-orange" typeBtn1="primary" btn1="SÍ, COPIAR" btn2="CANCELAR"  @btnEvent="saveCopy()" v-on:eventBtn="modalCopy = false">
              </AppModal>
              <!-- modal borrar -->
              <AppModal :show-dialog.sync="modalClean" v-if="modalClean" nameClass="dialog-red"  :rutImg="require(`@/assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
                parrafo="¿Seguro de que quieres borrar la información ingresada?"
                classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR"  @btnEvent="clean()" v-on:eventBtn="modalClean = false">
              </AppModal>
            </div>
          </el-card>
        </el-col>
      </el-main>
      <div style="margin-left:8%; width:84%">
        <el-row type="flex" justify="end">
          <el-col :span="6" >
            <el-button @click="cancel" size="small" style="margin-right:2rem" plain> CANCELAR </el-button>
            <el-button type="primary" @click="validateRecepcionOfMaterials()" size="small"> REGISTRAR </el-button>
          </el-col>
        </el-row>
      </div>
      <!-- Modal botón ingresar-->
      <!-- <AppModalSuccess :show-dialog.sync="registerModal" v-if="registerModal" 
        :parrafo="'Se guardo la información de la recepción de los materiales'"
        btn1="ACEPTAR"  @btnEvent="returnPage" v-on:btnEvent = "registerModal = false">
      </AppModalSuccess> -->

      <!-- Modal botón ingresar -->
      <el-dialog  
        :visible.sync="registerModal"
        width="33%" center
        :close-on-press-escape="false"
        :close-on-click-modal="false"
        :show-close="false"
        custom-class="dialog-orange">
        <el-row>
          <el-col :span="5" class="text-center"><img src="@/assets/images/happy.svg" alt="emoticon"></el-col>
          <el-col :span="18" :offset="1">
            <p class="fonts-bold-general" style="margin-bottom: 0.5rem">¡Buen trabajo!</p>
            <p style="line-height: 22px;"> Se guardó la información de los materiales.  </p>
            <p style="line-height: 22px;" v-if="numberMovement !== null"> El número de <span class='text-green text-bold'> MOVIMIENTO </span> es  <strong>  {{numberMovement }} </strong> .</p>
          </el-col>
        </el-row>
        <div style="text-align: right; margin-top: 15px;">
          <el-button @click="registerModal = false" v-on:click="returnPage" type="primary">ACEPTAR</el-button>
        </div>
      </el-dialog>

      <!-- Modal -->
      <AppModal :show-dialog.sync="cannotChangeStatus" v-if="cannotChangeStatus" nameClass="dialog-red" 
        :rutImg="require(`@/assets/images/alerta.svg`)" sizeImg="80%"  
        :parrafo="`No se puede cambiar de estado <strong>Recibido</strong> a <strong>Pendiente</strong>`">
      </AppModal>

      <!-- Modal validate reception -->
      <AppModal :show-dialog.sync="modalToContinue" v-if="modalToContinue" nameClass="dialog-red" :rutImg="require(`@/assets/images/alerta.svg`)" sizeImg="80px"  
        :parrafo="msgOfValidateReception" btn1="SI" btn2="CANCELAR" classBtn1="border-red" typeBtn1="danger"
        @btnEvent="register()" v-on:eventBtn="modalToContinue = false" >
      </AppModal> 
    </div>
  </div>
</template>
<style>
  .vigencia-size {
    width: 175px !important;
  }
  .size-arrival{
    width: 206px !important;
  }
  .margin-between {
    margin:0.5rem 0 
  }
  .arrow-gray {
    color:#828282
  }
</style>

<script>
import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import { modifyText } from '@/utils/modifyText.js'
import {HTTP} from '@/main.js'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    AppModal,
    AppModalSuccess,
  },
  data () {
    return {
      arrClean:[],
      checkAll: false,
      indexClean:'',
      isIndeterminate: true,
      materialsStorage:[], //admittedmaterial
      modalCopy: false,
      modalClean: false,
      paragraph: '',
      registerModal:false,
      storageId: this.$store.state.idContractRecp,
      contract: this.$store.state.contractRecp,
      textSearch: '',
      titleContract:'',
      totalMaterial:0,

      item:{},
      itemClean:'',
      index:'',
      array:[],
      typeCard:'',
      allFilters: [
        {value: 'Internet', label: 'Internet'},
        {value: 'Disco Duro', label: 'Disco duro'},
        {value: 'Thomson Kencast', label: 'Thomson Kencast'},
      ],
      allShipping: [
        {value: 'Fedex', label: 'Fedex'},
        {value: 'DHL', label: 'DHL'},
        {value: 'En mano', label: 'En mano'},
        {value: 'Aspera', label: 'Aspera'},
        {value: 'FTP', label: 'FTP'},
        {value: 'Thomson Kencast', label: 'Thomson Kencast'}  
      ],
      nameType: '',
      statusContract: '',
      numberMovement: null,
      cannotChangeStatus: false,
      msgOfValidateReception: '',
      modalToContinue: false
    }
  },
  computed:{
    searching () {
      //  buscador
      let filtered = this.materialsStorage
      console.log({filtered})
      return filtered.filter(
      m => modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1)
    },
    receivedMaterials(){
      let received = []
      this.materialsStorage.map((el)=>{
        if(el.statusMaterial === 3 || el.statusMaterial === 2){
          received.push(el.statusMaterial)
        }
      })
      return received.length
    }
  },
  created () {
    this.getContracts()
    this.receivedChapter()
  },
  beforeDestroy() {
    this.$store.dispatch('getData', "contracts")
    this.$store.dispatch("getData", "materials")
    this.$store.dispatch("getData", "movement")
  },
  methods: {
    getContracts () {
      console.log(this.contract, "contract")
      this.titleContract = this.contract.contractName
      this.materialsStorage = this.contract.admittedMaterials
      // this.materialsStorage = this.contract.refMaterials
      this.totalMaterial = this.contract.admittedMaterials.length
      this.$localStorage.set("originalInfoAdmittedMaterial", JSON.stringify(this.materialsStorage))
      
      // creando propiedad hideForm
      this.materialsStorage.map((elem) => {
        this.$set(elem, 'hideForm', false)
        
        if(elem.numChapters.length !== 0){
          this.$set(elem, 'selectSeason', '1')
          
          elem.numChapters.map((sea) => {
            sea.infoByChapter.map((chap)=>{
                if(chap.arrivalSupport == undefined) {
                  this.$set(chap, 'arrivalDate', '') 
                  this.$set(chap, 'guideNumber', '' ) 
                  this.$set(chap, 'shippingMode', '') 
                  this.$set(chap, 'statusChapter', 1) 
                  this.$set(chap, 'statusStorageChap', 1) 
                  this.$set(chap, 'copyBackup', '' ) 
                  this.$set(chap, 'dateOfCopy', '') 
                  this.$set(chap, 'storages', '') 
                  this.$set(chap, 'videoteca', '')
                  this.$set(chap, 'replacement', false) 
                  this.$set(chap, 'showreplace', '')
                  this.$set(chap, 'supportMaterial', [{"typeStorage": "","codeDisk": ""}]) 
                  this.$set(chap, 'replacementStorage', false)
                  this.$set(chap, 'hideChap', false),
                  this.$set(chap, 'reposicion', [])
                } else {
                  if(chap.replacement == true) {
                    let objectNew = {
                      arrivalDate: chap.arrivalDate,
                      guideNumber: chap.guideNumber,
                      shippingMode: chap.shippingMode,
                      copyBackup: chap.copyBackup,
                      dateOfCopy: chap.dateOfCopy,
                      storages: chap.storages,
                      videoteca: chap.videoteca,
                      supportMaterial: chap.supportMaterial,
                      replacementStorage: chap.replacementStorage,
                      arrivalSupport: chap.arrivalSupport
                    }
                    chap.reposicion.push(objectNew)
                      chap.arrivalDate = ''
                      chap.guideNumber = ''
                      chap.shippingMode = ''
                      chap.copyBackup = ''
                      chap.dateOfCopy = ''
                      chap.storages = ''
                      chap.videoteca = ''
                      chap.replacement = false
                      chap.supportMaterial = [{"typeStorage": "","codeDisk": ""}] 
                      chap.replacementStorage = false
                      chap.arrivalSupport = ''
                  }
                }
            })
          })
        }
        else {
          console.log('aqui sin capitulos')
          if(!elem.supportMaterial) {
            Object.defineProperty(elem, 'supportMaterial', {
              value: [{"typeStorage": "","codeDisk": ""}],
              writable: true,
              enumerable: true,
              configurable: true
            })
          }
          
          if(elem.infoSupport == undefined) {
            Object.defineProperty(elem, 'infoSupport', {
              value: [],
              writable: true,
              enumerable: true,
              configurable: true
            })

            let objetoP = {
              arrivalDate: '',
              guideNumber: '',
              shippingMode: '',
              copyBackup: '',
              dateOfCopy: '',
              storages: '',
              videoteca: '',
              replacement: false,
              showreplace: '',
              supportMaterial:  [
                {typeStorage: "",
                  codeDisk: ""}
              ],
              replacementStorage: false,
              statusMaterial: 1,
              statusStorage: 1,
              reposicion: []
            }
            elem.infoSupport.push(objetoP)

          }
          
          else {
            if(elem.replacement == true) {
              let objectNew = {
                arrivalDate: elem.arrivalDate,
                guideNumber: elem.guideNumber,
                shippingMode: elem.shippingMode,
                copyBackup: elem.copyBackup,
                dateOfCopy: elem.dateOfCopy,
                storages: elem.storages,
                videoteca: elem.videoteca,
                supportMaterial: elem.supportMaterial,
                replacementStorage: elem.replacementStorage,
                arrivalSupport: elem.arrivalSupport
              }

              if(elem.infoSupport.reposicion) {
                elem.infoSupport.reposicion.push(objectNew) 
                elem.arrivalDate = ''
                elem.guideNumber = ''
                elem.shippingMode = ''
                elem.copyBackup = ''
                elem.dateOfCopy = ''
                elem.storages = ''
                elem.videoteca = ''
                elem.replacement = false
                elem.supportMaterial = [{"typeStorage": "","codeDisk": ""}]
                elem.replacementStorage = false
                elem.arrivalSupport = ''
              }
            }
          }     
        }
      })
      // this.setGroupMat(this.materialsStorage)
    },
    receivedChapter(seas) {
      if(seas){
      let arrayReceivedMat = []
        seas.infoByChapter.map((el)=>{
          if(el.statusChapter === 2){
            arrayReceivedMat.push(el.statusChapter)
          }
        })
        return arrayReceivedMat.length
      }
    },
    // materialStatusChange(value){
    //   if(value === 3){
    //     this.isIndeterminate = true
    //   }else{
    //     this.isIndeterminate = false
    //   }
    // },
    changeStatusMaterial(...value) {
      let newState = value[0]
      let indexOfMaterial = value[1]
      let materialSelected = this.searching[indexOfMaterial]
      if(newState == 1){
        if(materialSelected.numChapters.length > 0){
          let indexOfSeason = value[2]
          let indexOfChapter = value[3]
          materialSelected.numChapters[indexOfSeason].infoByChapter[indexOfChapter].statusChapter = 2
        } else {
          materialSelected.statusMaterial = 3
        }
        this.cannotChangeStatus = true
      }
    },
    btnClean(index, arr, itemType){
     this.modalClean = true
     this.indexClean = index
     this.arrClean = arr
     this.itemClean = itemType
    },
    clean(){
      // boton borrador
      let updateMat = this.arrClean[ this.indexClean]

      if(this.itemClean === 'materialall'){ // boton donde trae el material
        if(updateMat.numChapters.length !== 0){
          // ingresando a cada capitulo
          updateMat.numChapters.map((el)=>{
            // ingresando a cada capitulo
            el.infoByChapter.map((chap)=>{
              chap.arrivalDate = ''
              chap.arrivalSupport = ''
              chap.guideNumber = ''
              chap.shippingMode= ''
              chap.statusChapter= 1
            })
          })
        }
        else{
          this.arrClean[this.indexClean].arrivalDate= ''
          this.arrClean[this.indexClean].arrivalSupport= ''
          this.arrClean[this.indexClean].guideNumber= ''
          this.arrClean[this.indexClean].shippingMode= ''
          this.arrClean[this.indexClean].statusMaterial= 1

        }
      }
      else{ // boton donde trae capitulo
        console.log('capitulo')
        this.arrClean[this.indexClean].arrivalDate= ''
        this.arrClean[this.indexClean].arrivalSupport= ''
        this.arrClean[this.indexClean].guideNumber= ''
        this.arrClean[this.indexClean].shippingMode= ''
        this.arrClean[this.indexClean].statusChapter= 1
      }

      this.modalClean = false
    },
    returnPage() {
      this.$router.push({ name: 'reception' })
    },
    showFormCard(index){
      // toogle button
      let updateMat= this.materialsStorage[index]    
      updateMat.hideForm = !updateMat.hideForm     
    },
    showCap(index, ind, j){
      // material actual
      let updateMat= this.materialsStorage[index]
      // temporada actual
      let updateSeason = updateMat.numChapters[ind]
      // capitulo actual
      let updateChap = updateSeason.infoByChapter[j]
      updateChap.hideChap = !updateChap.hideChap
    },
    btnCopy(item, index, array, typeCard){
      // boton copiar
      (typeCard === 'nochap')? this.paragraph ='¿Quieres copiar la información en todos los materiales?':this.paragraph = '¿Quieres copiar la información en todos los capítulos?'
      this.modalCopy = true
      this.item = item
      this.index = index
      this.array = array
      this.typeCard = typeCard     
    },
    items (el){
      el.arrivalDate = this.item.arrivalDate
      el.arrivalSupport = this.item.arrivalSupport
      el.guideNumber = this.item.guideNumber
      el.shippingMode = this.item.shippingMode
    },
    saveCopy(){
      if(this.typeCard === 'nochap'){
        console.log('sin capitulo')
        this.array.map((el, i)=>{       
          if(i > this.index){
            this.items(el)
            el.statusMaterial = this.item.statusMaterial  
          }
          
        })
      }else{
        this.array.map((el, i)=>{
          if(i > this.index){
            this.items(el)
            el.statusChapter = this.item.statusChapter 
          }
        })
      }
      this.modalCopy = false
    },
    getMaterialsComplete () {
      let allCapMovement = []
      // let action
      let originalInfoAdmittedMaterial =  JSON.parse(this.$localStorage.get("originalInfoAdmittedMaterial"))
      // console.log(originalInfoAdmittedMaterial, 'originalInfoAdmittedMaterial')
      this.materialsStorage.map(( el, i, arr ) => {
        // SIN CAPITULOS  
        if (originalInfoAdmittedMaterial[i].numChapters.length == 0) {
          if ( (originalInfoAdmittedMaterial[i].statusMaterial !== el.statusMaterial) && (el.statusMaterial == 3) && (el.showreplace !== 'REPOSICIÓN')) {
            let object = {
              refMaterials: [ el._id ],
              codMaterial: el.codMaterial,
              numberCap: null,
              typeOfContent: el.typeOfContent,
              ownTitle: el.ownTitle,
              unitPrice: el.unitPrice,
              currencySymbol: el.currencySymbol
            }        
            allCapMovement.push(object)
          }
        }
        else {
          // CON CAPITULOS
          let filterCapCopy = el.numChapters[0].infoByChapter.filter(( m, j ) => {
            return m.statusChapter !=  originalInfoAdmittedMaterial[i].numChapters[0].infoByChapter[j].statusChapter && m.statusChapter == 2 && m.showreplace !== 'REPOSICIÓN'
          });
          filterCapCopy.map((ella, h) => {
            console.log(el.numChapters[0].arrOfChapters, 'el.numChapters[0].arrOfChapters')
            let filterArrayPrice = el.numChapters[0].arrOfChapters.filter(( m, j )=> {
              return m.id == ella.chapter
            });

            let object = {
              refMaterials: [ el._id ],
              codMaterial: el.codMaterial,
              numberCap: filterArrayPrice[0].id,
              typeOfContent: el.typeOfContent,
              ownTitle: el.ownTitle,
              unitPrice: filterArrayPrice[0].unitPrice,
              currencySymbol: filterArrayPrice[0].currencySymbol
            } 
            allCapMovement.push(object)
          })
        }
      })
      return allCapMovement
    },
    postNewMovement ( objectInfo, seq ) {
      HTTP.post(`movement`, objectInfo)
      .then(res => {
        this.registerModal = true
      })
      .catch(err => console.log(err));
    },
    getSequencesMovement ( allMaterialInMovement ) {
     HTTP.get('sequences/increment/verify')
      .then(res => { 
        console.log(res, res.data.seq , 'res increment')   
        this.numberMovement = res.data.seq 
        let objectInfo = {
          registrationDate: new Date(),
          year: new Date().getFullYear(),
          month: new Date().getMonth()+1,
          contractName: this.contract.contractName,
          contractCode: this.contract.contractCode,
          providerCode: this.contract.providerCode,
          currencySymbol: this.contract.currencySymbol,
          movementNumber: res.data.seq,
          materialsRegistration: allMaterialInMovement,
          contratoDistribuidor: this.contract.contratoDistribuidor
        }
        this.postNewMovement( objectInfo, res.data.seq )
      })
      .catch(err => {
        console.log(err);
      });
    },
    movementUpdate(data) {
      let objectInfo = {
        registrationDate: new Date(),
        year: new Date().getFullYear(),
        month: new Date().getMonth()+1,
        contractName: this.contract.contractName,
        contractCode: this.contract.contractCode,
        providerCode: this.contract.providerCode,
        // movementNumber: res.data.seq,
        materialsRegistration: data,
        contratoDistribuidor: this.contract.contratoDistribuidor
      }
    },
    saveContracts () {
      let materialsStorage = this.materialsStorage
      //Se comenta porque en produccion aun no se genera movimientos
      //  let response = this.getMaterialsComplete()
      // if (response.length > 0) {
      //   this.getSequencesMovement ( response )
      // } 

      // this.patchMaterialMovement(materialsStorage)
      HTTP.patch('contracts/' + this.storageId,
        [
          { propName: "nameType", value: this.nameType},
          { propName: "statusContract", value: this.statusContract},
          { propName: "admittedMaterials", value: materialsStorage},
        ]
      )
      .then(res => {
        let dataType = "contracts"
        this.registerModal = true
      })
      .catch(err => console.log(err))
    },
    patchMaterialMovement(data) {
      data.forEach((el) => {
        const {shippingMode, guideNumber, arrivalSupport} = el
        let obj = {
          arrivalSupport, shippingMode, guideNumber
        }
        console.log(el.numChapters.map((e) => e.infoByChapter), 'el.numChapters.map((e) => e.infoByChapter)')
        let conditional = el.numChapters.length > 0 ? el.numChapters.map((e) => e.infoByChapter) : [obj]
        HTTP.patch(`materials/${el._id}`,[
          { propName: "movementData", value: conditional},
        ])
        .then(res => {
          console.log(res, 'res')
        })
        .catch(err => console.log(err))
      })
    },
    saveMaterial() {
      let materialsStorage = this.materialsStorage
      for(let i = 0; i < this.materialsStorage.length; i++) {
        let numb = this.materialsStorage[i].numChapters
       let existNumberChapters = numb.length > 0 ?  true : false

       if ( !existNumberChapters ) {
         console.log("patch material sin capitulos ")
          let info = {
            "arrivalDate": this.materialsStorage[i].arrivalDate || '',
            "guideNumber": this.materialsStorage[i].guideNumber || '',
            "shippingMode": this.materialsStorage[i].shippingMode || '',
            "copyBackup": this.materialsStorage[i].copyBackup || '',
            "dateOfCopy": this.materialsStorage[i].dateOfCopy || '',
            "storages": this.materialsStorage[i].storages || '',
            "videoteca": this.materialsStorage[i].videoteca || '',
            "replacement": this.materialsStorage[i].replacement || false,
            "showreplace": this.materialsStorage[i].showreplace || '',
            "supportMaterial": this.materialsStorage[i].supportMaterial || [{"typeStorage": "","codeDisk": ""}],
            "replacementStorage": this.materialsStorage[i].replacementStorage || false,
            "arrivalSupport": this.materialsStorage[i].arrivalSupport || '',
            "statusMaterial": this.materialsStorage[i].statusMaterial || '',
            "statusStorage": this.materialsStorage[i].statusStorage || ''
          }

         HTTP.patch(`materials/update/${this.materialsStorage[i]._id}`, [{propName: "infoSupport", value: info}])
          .then(res => {
              let payload = {
                type: 'materials',
                typeFilter: 'materialType',
                typeOfContent: '',
                typeMaterial: 'Enlatado',
                typeFilter2: 'providerName'
              }

              if( this.materialsStorage[i].typeOfContent == 'LARGOMETRAJES' ) {
                payload.typeOfContent = 'Largometrajes'
              }
              else if (this.materialsStorage[i].typeOfContent == 'MINI SERIE') {
                payload.typeOfContent = 'Miniseries'
              }
              else if (this.materialsStorage[i].typeOfContent == 'ESPECIALES') {
                payload.typeOfContent = 'Especial'
              }
              else {
                payload.typeOfContent = this.materialsStorage[i].typeOfContent
              }
      
              this.$store.dispatch('getDataFilters', payload)  

           })
          .catch(err => console.log(err))
       }
      }
    },
    validateRecepcionOfMaterials() {
      let matWithoutChapters = []
      let matWithChapters = []
      this.materialsStorage.map((material)=>{
        if(material.numChapters.length > 0){
          let chaptersToValidate = []
          material.numChapters[0].infoByChapter.map((chapter)=>{
            let validate = chapter.arrivalDate !== '' && chapter.arrivalSupport !== '' && chapter.shippingMode !== '' && chapter.guideNumber !== ''
            if(chapter.statusChapter == 1 && validate){
              chaptersToValidate.push(chapter.chapter)
            }
          })
          if(chaptersToValidate.length > 0){
            matWithChapters.push(material.listTitle)
          }
        } else {
          let hasContent = material.arrivalDate && material.arrivalSupport && material.shippingMode && material.guideNumber
          if(material.statusMaterial == 1 && hasContent){
            matWithoutChapters.push(material.listTitle)
          }
        }
      })
      
      if(matWithoutChapters.length > 0 || matWithChapters.length > 0){
        if(matWithoutChapters.length > 0 && matWithChapters.length >0){
          this.msgOfValidateReception = `No se ha cambiado el estado de <strong>${matWithoutChapters.join(', ')}</strong> y de los capítulos de <strong>${matWithChapters.join(', ')}</strong> a pesar de tener la recepción completa.<br> ¿Desea continuar?`
        } else if(matWithoutChapters.length > 0){
          if(matWithoutChapters.length == 1){
            this.msgOfValidateReception = `No se ha cambiado el estado del material <strong> ${matWithoutChapters[0]}</strong> a pesar de tener la recepción completa.<br> ¿Desea continuar?`
          } else {
            this.msgOfValidateReception = `No se ha cambiado el estado de materiales <strong>${matWithoutChapters.join(', ')}</strong> a pesar de tener la recepción completa.<br> ¿Desea continuar?`
          }
        } else if(matWithChapters.length > 0){
          this.msgOfValidateReception = `No se ha cambiado el estado de los capítulos de ${matWithChapters.join(', ')}</strong> a pesar de tener la recepción completa.<br> ¿Desea continuar?`
        }
        
        this.modalToContinue = true
      } else {
        this.register()
      }
    },
    register() {
      this.saveMaterial()

      let statusContract = ''
      let materialsStorage = this.materialsStorage // materiales del contrato
      let totalMaterial = materialsStorage.length //total de materiales
      
      let arrayMatStatus3 = []
      let arrayMatStatus2 = []

      materialsStorage.map((el)=>{
        if(el.statusMaterial === 3){
          arrayMatStatus3.push(3)
        } 
        if(el.statusMaterial === 2){
          arrayMatStatus2.push(2)
        }
      })

      if(arrayMatStatus3.length === totalMaterial) {
        statusContract = 'COMPLETO'
      }else if (arrayMatStatus3.length === 0 && arrayMatStatus2.length === 0) {
        statusContract = 'PENDIENTE'
      }else {
        statusContract = 'INCOMPLETO'
      }

      let nameType
      (statusContract=== 'COMPLETO')? nameType = 'success':  (statusContract=== 'INCOMPLETO')? nameType = 'danger':nameType = 'info'
      this.nameType = nameType
      this.statusContract = statusContract

      this.saveContracts()

    },
    cancel() {
      this.$router.push({ name: 'reception' })
    },
    concatObjects() {
      let material = this.informationMaterial.numChapters[0].infoByChapter
      let keysAboutOnlyInMaterial = material.map( (e) => ({
        guestArtis: e.guestArtis,
        tags: e.tags,
        contentObservations: e.contentObservations,
        technicalObservationsOfColor: e.technicalObservationsOfColor,
        audioTechnicalObservations: e.audioTechnicalObservations,
        technicalObservationsVideo: e.technicalObservationsVideo,
        needEditContentChapter: e.needEditContentChapter,
        needRepColorChapter: e.needRepColorChapter,
        needRepAudioChapter: e.needRepAudioChapter,
        needRepVideoChapter: e.needRepVideoChapter,
        screenResolutionChapter: e.screenResolutionChapter,
        screenChapter: e.screenChapter,
        observations: e.observations,
        colorCap: e.colorCap,
        state: e.state
      }))
      let contract = this.informationContract.admittedMaterials[0].numChapters[0].infoByChapter
      for(let i = 0; i < contract.length; i++) {
        let newInfo = []
        let concat = Object.assign(contract[i], ...keysAboutOnlyInMaterial)
        newInfo.push(concat)
        this.materialsStorage[0].numChapters[0].infoByChapter = newInfo
      }      
    },
    readyGetMaterials() {
      this.contract.admittedMaterials.map((e) => {
        HTTP.get(`materials/${e._id}`)
        .then(res => {
          this.informationMaterial = res.data.material
          this.concatObjects()
        })
        .catch(err => console.log(err))
      })
    },
    chooseGuideNumber(arrivalDate, arrivalSupport, shippingMode) {
      if((!arrivalDate || arrivalDate == '') || (!arrivalSupport || arrivalSupport == '') || (!shippingMode ||shippingMode == '')){
        return true
      } else {
        return false
      }
    }
  }
}
</script>
